Index: code/branches/pickup/src/external/bullet/BulletCollision/CMakeLists.txt
===================================================================
--- code/branches/pickup/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 5815)
+++ code/branches/pickup/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 5935)
@@ -1,3 +1,6 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletCollisionCompilation.cpp
+
 	BroadphaseCollision/btAxisSweep3.cpp
 	BroadphaseCollision/btBroadphaseProxy.cpp
@@ -68,13 +71,9 @@
 	Gimpact/btContactProcessing.cpp
 	Gimpact/btGImpactShape.cpp
-	Gimpact/gim_contact.cpp
 	Gimpact/btGImpactBvh.cpp
 	Gimpact/btGenericPoolAllocator.cpp
-	Gimpact/gim_memory.cpp
 	Gimpact/btGImpactCollisionAlgorithm.cpp
 	Gimpact/btTriangleShapeEx.cpp
-	Gimpact/gim_tri_collision.cpp
 	Gimpact/btGImpactQuantizedBvh.cpp
-	Gimpact/gim_box_set.cpp
 
 	NarrowPhaseCollision/btContinuousConvexCollision.cpp
@@ -89,4 +88,13 @@
 	NarrowPhaseCollision/btSubSimplexConvexCast.cpp
 	NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
+
+COMPILATION_END
+
+COMPILATION_BEGIN BulletGImpactCompilation.cpp
+	Gimpact/gim_contact.cpp
+	Gimpact/gim_memory.cpp
+	Gimpact/gim_tri_collision.cpp
+	Gimpact/gim_box_set.cpp
+COMPILATION_END
 
 	# Headers
Index: code/branches/pickup/src/external/bullet/BulletDynamics/CMakeLists.txt
===================================================================
--- code/branches/pickup/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 5815)
+++ code/branches/pickup/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 5935)
@@ -1,3 +1,6 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletDynamicsCompilation.cpp
+
 	ConstraintSolver/btContactConstraint.cpp
 	ConstraintSolver/btConeTwistConstraint.cpp
@@ -19,4 +22,6 @@
 
 	Character/btKinematicCharacterController.cpp
+
+COMPILATION_END
 
 	# Headers
Index: code/branches/pickup/src/external/bullet/BulletPrecompiledHeaders.h
===================================================================
--- code/branches/pickup/src/external/bullet/BulletPrecompiledHeaders.h	(revision 5815)
+++ 	(revision )
@@ -1,48 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-@file
-@brief
-    Compilation of the most often used header files in the external bullet library
-@details
-    Updated: 19. September 2009
-    Total Files: 105
-*/
-
-///////////////////////////////////////////
-/////          Stable Headers         /////
-///////////////////////////////////////////
-
-#include <bullet/BulletCollision/CollisionShapes/btConvexInternalShape.h> // 37
-#include <bullet/BulletCollision/CollisionDispatch/btCollisionObject.h> // 33
-
-
-// Just in case some header included windows.h
-#undef min
-#undef max
Index: code/branches/pickup/src/external/bullet/CMakeLists.txt
===================================================================
--- code/branches/pickup/src/external/bullet/CMakeLists.txt	(revision 5815)
+++ code/branches/pickup/src/external/bullet/CMakeLists.txt	(revision 5935)
@@ -27,13 +27,7 @@
 ADD_SUBDIRECTORY(LinearMath)
 
-# No warnings needed from third party libraries
-REMOVE_COMPILER_FLAGS("-W3 -W4" MSVC)
-ADD_COMPILER_FLAGS("-w")
-
 ORXONOX_ADD_LIBRARY(bullet_orxonox
   ORXONOX_EXTERNAL
   NO_DLL_INTERFACE
-  PCH_FILE
-    BulletPrecompiledHeaders.h
   VERSION
     2.74
Index: code/branches/pickup/src/external/bullet/LinearMath/CMakeLists.txt
===================================================================
--- code/branches/pickup/src/external/bullet/LinearMath/CMakeLists.txt	(revision 5815)
+++ code/branches/pickup/src/external/bullet/LinearMath/CMakeLists.txt	(revision 5935)
@@ -1,7 +1,10 @@
 ADD_SOURCE_FILES(BULLET_FILES
+
+COMPILATION_BEGIN BulletLinearMathCompilation.cpp
 		btConvexHull.cpp
 		btQuickprof.cpp
 		btGeometryUtil.cpp
 		btAlignedAllocator.cpp
+COMPILATION_END
 
 		# Headers