Index: branches/powerups/src/world_entities/extendable.h
===================================================================
--- branches/powerups/src/world_entities/extendable.h	(revision 5973)
+++ branches/powerups/src/world_entities/extendable.h	(revision 5985)
@@ -12,4 +12,5 @@
 class PowerUp;
 
+#include "power_ups/power_up.h"
 
 //! A class for ...
@@ -19,5 +20,5 @@
 //   Extendable();
 //   virtual ~Extendable();
-  virtual bool pickup(PowerUp* powerUp) { return false; }
+   virtual bool pickup(PowerUp* powerUp) { return false; };
 
  private:
Index: branches/powerups/src/world_entities/player.h
===================================================================
--- branches/powerups/src/world_entities/player.h	(revision 5973)
+++ branches/powerups/src/world_entities/player.h	(revision 5985)
@@ -8,4 +8,5 @@
 
 #include "event_listener.h"
+#include "extendable.h"
 
 /* Forward Declaration */
@@ -18,4 +19,5 @@
      the player.cc for debug also
 */
+
 class Player : public EventListener
 {
Index: branches/powerups/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/powerups/src/world_entities/space_ships/space_ship.cc	(revision 5973)
+++ branches/powerups/src/world_entities/space_ships/space_ship.cc	(revision 5985)
@@ -31,6 +31,9 @@
 #include "factory.h"
 #include "key_mapper.h"
+#include "event_handler.h"
 
 #include "power_ups/weapon_power_up.h"
+
+#include "graphics_engine.h"
 
 using namespace std;
@@ -88,5 +91,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::getFirst()->fabricate(CL_CANNON));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
 
   cannon->setName("BFG");
@@ -112,7 +115,13 @@
   PRINTF(4)("SPACESHIP INIT\n");
 
-
-  bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
+  EventHandler::getInstance()->grabEvents(true);
+
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
   bFire = false;
+  xMouse = yMouse = 0;
+  mouseSensitivity = 0.001;
+
+  cycle = 0.0;
+
 
   travelSpeed = 15.0;
@@ -126,8 +135,10 @@
 
   //add events to the eventlist
-  registerEvent(KeyMapper::PEV_UP);
-  registerEvent(KeyMapper::PEV_DOWN);
-  registerEvent(KeyMapper::PEV_LEFT);
-  registerEvent(KeyMapper::PEV_RIGHT);
+  registerEvent(SDLK_w);
+  registerEvent(SDLK_s);
+  registerEvent(SDLK_a);
+  registerEvent(SDLK_d);
+  registerEvent(SDLK_q);
+  registerEvent(SDLK_e);
   registerEvent(KeyMapper::PEV_FIRE1);
   registerEvent(KeyMapper::PEV_NEXT_WEAPON);
@@ -135,4 +146,5 @@
   registerEvent(SDLK_PAGEUP);
   registerEvent(SDLK_PAGEDOWN);
+  registerEvent(EV_MOUSE_MOTION);
 
   this->getWeaponManager()->setSlotCount(7);
@@ -255,4 +267,5 @@
 void SpaceShip::tick (float time)
 {
+     cycle += time;
   // spaceship controlled movement
   this->calculateVelocity(time);
@@ -261,4 +274,11 @@
 
   //orient the spaceship model in the direction of movement.
+
+  // this is the air friction (necessary for a smooth control)
+  if(velocity.len() != 0) velocity -= velocity*0.01;
+
+  this->shiftCoor(Vector(0,1,0)*cos(this->cycle*2.0)*0.02);
+
+  //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
 
   this->shiftCoor (move);
@@ -283,12 +303,12 @@
   if( this->bUp )
    {
-     this->shiftCoor(this->getAbsDirX());
-      //if(travelSpeed <= 5000)  travelSpeed += 10;
+     //this->shiftCoor(this->getAbsDirX());
+      accel += (this->getAbsDirX())*2;
    }
 
   if( this->bDown )
    {
-     this->shiftCoor(Vector()-this->getAbsDirX());
-     //if(travelSpeed >= 10) travelSpeed -= 10;
+     //this->shiftCoor((this->getAbsDirX())*-1);
+     accel -= (this->getAbsDirX())*2;
    }
 
@@ -310,4 +330,22 @@
     //rotVal += .4;
   }
+
+  if( this->bRollL /* > -this->getRelCoor().z*2*/)
+  {
+    this->shiftDir(Quaternion(-time, Vector(1,0,0)));
+//    accel -= rightDirection;
+    //velocityDir.normalize();
+    //rot +=Vector(1,0,0);
+    //rotVal -= .4;
+  }
+  if( this->bRollR /* > this->getRelCoor().z*2*/)
+  {
+    this->shiftDir(Quaternion(time, Vector(1,0,0)));
+
+    //    accel += rightDirection;
+    //velocityDir.normalize();
+    //rot += Vector(1,0,0);
+    //rotVal += .4;
+  }
   if (this->bAscend )
   {
@@ -329,5 +367,5 @@
   }
 
-  velocity += accel*(time);
+  velocity += accel;
   //rot.normalize();
   //this->setRelDirSoft(Quaternion(rotVal, rot), 5);
@@ -350,12 +388,10 @@
 void SpaceShip::process(const Event &event)
 {
-  if( event.type == KeyMapper::PEV_UP)
-      this->bUp = event.bPressed;
-  else if( event.type == KeyMapper::PEV_DOWN)
-      this->bDown = event.bPressed;
-  else if( event.type == KeyMapper::PEV_RIGHT)
-      this->bRight= event.bPressed;
-  else if( event.type == KeyMapper::PEV_LEFT)
-      this->bLeft = event.bPressed;
+
+
+  if( event.type == SDLK_a)
+      this->bRollL = event.bPressed;
+  else if( event.type == SDLK_d)
+      this->bRollR = event.bPressed;
   else if( event.type == KeyMapper::PEV_FIRE1)
       this->bFire = event.bPressed;
@@ -365,8 +401,14 @@
     this->getWeaponManager()->previousWeaponConfig();
 
-  else if( event.type == SDLK_PAGEUP)
-    this->bAscend = event.bPressed; //this->shiftCoor(0,.1,0);
-  else if( event.type == SDLK_PAGEDOWN)
-    this->bDescend = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == SDLK_w)
+    this->bUp = event.bPressed; //this->shiftCoor(0,.1,0);
+  else if( event.type == SDLK_s)
+    this->bDown = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == EV_MOUSE_MOTION)
+  {
+    this->xMouse = event.xRel;
+    this->yMouse = event.yRel;
+    this->shiftDir(Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0))*Quaternion(-M_PI/4*yMouse*mouseSensitivity, Vector(0,0,1)));
+  }
 }
 
Index: branches/powerups/src/world_entities/space_ships/space_ship.h
===================================================================
--- branches/powerups/src/world_entities/space_ships/space_ship.h	(revision 5973)
+++ branches/powerups/src/world_entities/space_ships/space_ship.h	(revision 5985)
@@ -58,4 +58,11 @@
     bool                  bDescend;           //!< descend button presses.
     bool                  bFire;              //!< fire button pressed.
+    bool                  bRollL;             //!< rolling button pressed (left)
+    bool                  bRollR;             //!< rolling button pressed (right)
+    
+    float                 xMouse;             //!< mouse moved in x-Direction
+    float                 yMouse;             //!< mouse moved in y-Direction
+    float                 mouseSensitivity;   //!< the mouse sensitivity
+    float                 cycle;              //!< hovercycle
 
     Vector                velocity;           //!< the velocity of the player.
Index: branches/powerups/src/world_entities/weapons/crosshair.cc
===================================================================
--- branches/powerups/src/world_entities/weapons/crosshair.cc	(revision 5973)
+++ branches/powerups/src/world_entities/weapons/crosshair.cc	(revision 5985)
@@ -70,5 +70,5 @@
   this->material = new Material;
 
-  EventHandler::getInstance()->subscribe(this, ES_GAME, EV_MOUSE_MOTION);
+  //EventHandler::getInstance()->subscribe(this, ES_GAME, EV_MOUSE_MOTION);
 
   // center the mouse on the screen, and also hide the cursors
@@ -122,5 +122,5 @@
   if  (event.type == EV_MOUSE_MOTION)
   {
-    this->setAbsCoor2D(event.x, event.y);
+    //this->setAbsCoor2D(event.x, event.y);
   }
 }
@@ -157,5 +157,5 @@
                &objZ );
 
-  this->setAbsCoor(objX, objY, objZ);
+  //this->setAbsCoor(objX, objY, objZ);
 }
 
@@ -166,5 +166,5 @@
 {
   glPushMatrix();
-  glTranslatef(this->getAbsCoor2D().x, this->getAbsCoor2D().y, 0);
+  glTranslatef(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2, 0);
 
   glRotatef(this->getAbsDir2D(), 0,0,1);
Index: branches/powerups/src/world_entities/weapons/ground_turret.cc
===================================================================
--- branches/powerups/src/world_entities/weapons/ground_turret.cc	(revision 5973)
+++ branches/powerups/src/world_entities/weapons/ground_turret.cc	(revision 5985)
@@ -85,5 +85,5 @@
   element = root->FirstChildElement("weapon-left");
   if (element != NULL) element = element->FirstChildElement();
-  this->left = dynamic_cast<Weapon*>( Factory::getFirst()->fabricate( element) );
+  this->left = dynamic_cast<Weapon*>( Factory::fabricate( element) );
   if (this->left)
   {
@@ -94,5 +94,5 @@
   element = root->FirstChildElement("weapon-right");
   if (element != NULL)  if (element != NULL) element = element->FirstChildElement();
-  this->right = dynamic_cast<Weapon*>( Factory::getFirst()->fabricate( element) );
+  this->right = dynamic_cast<Weapon*>( Factory::fabricate( element) );
   if (this->right)
   {
Index: branches/powerups/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- branches/powerups/src/world_entities/weapons/weapon_manager.cc	(revision 5973)
+++ branches/powerups/src/world_entities/weapons/weapon_manager.cc	(revision 5985)
@@ -140,5 +140,5 @@
   LOAD_PARAM_START_CYCLE(root, element);
 
-  Weapon* newWeapon = dynamic_cast<Weapon*>(Factory::getFirst()->fabricate(element));
+  Weapon* newWeapon = dynamic_cast<Weapon*>(Factory::fabricate(element));
   /// @todo implement this !!
 